<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsVendor extends JPlugin
{
	function plgJoomsuite_content_fieldsVendor( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'vendor') return;

		$options[] = JHTML::_('select.option', '-1', '- '. JText::_('All').' -');
		$options[] = JHTML::_('select.option', 'name', 'Shop name');
		$options[] = JHTML::_('select.option', 'description', 'Description');
		$options[] = JHTML::_('select.option', 'email', 'Email');
		$options[] = JHTML::_('select.option', 'street', 'Street Address');
		$options[] = JHTML::_('select.option', 'state', 'State');
		$options[] = JHTML::_('select.option', 'country', 'Country');
		$options[] = JHTML::_('select.option', 'town', 'Town/Suburb');
		$options[] = JHTML::_('select.option', 'zip', 'Postal code/ZIP');
		$options[] = JHTML::_('select.option', 'tel', 'Tel');
		$options[] = JHTML::_('select.option', 'misc', 'Misc info');
		$options[] = JHTML::_('select.option', 'fax', 'Fax');
		$multiselect = 'size="'.count($options).'" multiple';

		$out	= JHTML::_('select.genericlist',  $options,
            "fields[".$obj->id."][]", $multiselect, 'value', 'text', ($obj->field_value ? explode('|',$obj->field_value) : '') );
		echo $out;
			
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'vendor') return;
		if(!$value) return;
		$value = implode('|', $value);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
	
		if($type != 'vendor') return;
		if( !$field->field_value ) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;

		$db = & JFactory::getDBO();

		$val = $field->field_value;
		
		$section = ResHelper::getCategorySection(JRequest::getInt('category_id'));
		
		
		$sql = "SELECT params FROM #__jc_users WHERE user_id = '$user' and section_id = '$section' ";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		{
			$info = new JParameter($res);

			$pre = 'usr_shop_';
			$out = '<table cellpadding="2" cellspacing="2" width="100%" class="small">';

			$list = explode('|', $val);
			if($val == -1 || in_array(-1, $list))
			{
				if($info->get($pre.'name'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Shop Name').':</td><td>'.$info->get($pre.'name').'</td></tr>';
				if($info->get($pre.'description'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Description').':</td><td>'.$info->get($pre.'description').'</td></tr>';
				if($info->get($pre.'email'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Email').':</td><td>'.$info->get($pre.'email').'</td></tr>';
				if($info->get($pre.'street'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Street Adress').':</td><td>'.$info->get($pre.'street').'</td></tr>';
				if($info->get($pre.'state'))$out .= '<tr><td width="20%" nowrap>'.JText::_('State').':</td><td>'.$info->get($pre.'state').'</td></tr>';
				if($info->get($pre.'country'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Country').':</td><td>'.$info->get($pre.'country').'</td></tr>';
				if($info->get($pre.'town'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Town/Suburb').':</td><td>'.$info->get($pre.'town').'</td></tr>';
				if($info->get($pre.'zip'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Postal code/ZIP').':</td><td>'.$info->get($pre.'zip').'</td></tr>';
				if($info->get($pre.'tel'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Telephone').':</td><td>'.$info->get($pre.'tel').'</td></tr>';
				if($info->get($pre.'misc'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Miscellaneous Information').':</td><td>'.$info->get($pre.'misc').'</td></tr>';
				if($info->get($pre.'fax'))$out .= '<tr><td width="20%" nowrap>'.JText::_('Fax').':</td><td>'.$info->get($pre.'fax').'</td></tr>';
			}
			else
			{
				$title = array('name' => JText::_('Shop Name'), 'description'=>JText::_('Description'), 'email'=>JText::_('Email'),
				'street'=>JText::_('Street Address'), 'state'=>JText::_('State'), 'country'=>JText::_('Country'),
				 'town'=>JText::_('Town/Suburb'), 'zip'=>JText::_('Postal code/ZIP'), 
				'tel'=>JText::_('Telephone'), 'misc'=>JText::_('Miscellaneous Information'), 'fax'=>JText::_('Fax'));
				foreach($list as $val)
				{
					if($info->get($pre.$val))
					$out .= '<tr><td width="20%" nowrap>'.$title[$val].':</td><td>'.$info->get($pre.$val).'</td></tr>';
				}
			}
			$inbox = JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'jsinbox.php';
			if($params->get('contact_now') && file_exists($inbox))
			{
				$author = JFactory::getUser($user);
				$cuser = JFactory::getUser();
				$uri = JFactory::getURI();
				$name = $cuser->id ? str_replace("\n", "", $cuser->name) : JText::_('User'); 
				$subject = str_replace("[USERNAME]", $name, JText::_('Message from [USERNAME]'));
				$sql = "SELECT id FROM #__js_inbox_types WHERE def = '1'";
				$db->setQuery($sql);
				$type_id = $db->loadResult();
				$link = JURI::root()."index.php?option=com_jsinbox&view=compose&type_id=".$type_id."&subject=".$subject.'&sto[0][to]='.$author->username;
				$link .= "&return=".base64_encode($uri->toString());
				$link .= '&Itemid='.($params->get('itemid', JRequest::getInt('Itemid')));
				
				$out .= '
					<tr>
						<td colspan="2">
							<input type="button" class="button" value="'.JText::_('Contact now').'" 
							onclick="parent.document.location = \''.$link.'\'">
						</td>
					</tr>';
			}
			$out .= '</table>';
		}
	}

}
?>